## Welcome! This is a building guide for RS Desktop


### Prerequisites:
- [VSCode](https://github.com/e3kskoy7wqk/vscode-for-windows-7) or anything similar (optional but recommended)
- [NodeJS 16](https://nodejs.org/dist/v16.20.2/node-v16.20.2-x64.msi) - Yes, it's outdated, we just didn't have the time to update the project to a more recent version.
- [The special Electron](https://github.com/e3kskoy7wqk/Electron-for-windows-7)

### Building
1. clone or download this repository

```git clone https://git.randomserver.top/legacytard-association/converse.rs.git```

2. Open a terminal in VSCode, and type the following commands

```npm i```

```$(npm bin)/electron-rebuild```

3. To build this into an asar, you run this command

```npx electron-builder```

After that,

- Go to dist > win-unpackaged > resources in your app's build.
- Copy the .asar file you find there.
- Paste it into the resources folder of the special Electron (replacing its existing .asar if needed).


4. Testing a build without packaging into an asar (Windows 10+ only)

```npm start```

If you are wondering why you can only test this on windows 10 without packaging, it is because [electron added ESM support in electron 28](https://www.electronjs.org/blog/electron-28-0#highlights), not 22. RS Desktop uses ESM, not CommonJS.

If you happen to be a windows 8.1 and under user, you can still test this, but you have to package it into an asar everytime, as seen in step 3.

### Good luck building RS Desktop, fellow developers =)





